# actionHero.js 
## The Reusable, Scalable, and Quick node.js API Server

**Links: [NPM](https://npmjs.org/package/actionHero) | [Wiki](https://github.com/evantahler/actionHero/wiki) | [API Methods](https://github.com/evantahler/actionHero/wiki/API-Methods) | [Public Site](http://www.actionherojs.com) | [GitHub](https://github.com/evantahler/actionHero) | [Mailing List](https://groups.google.com/forum/?fromgroups=#!forum/actionhero-js) | [Client](https://github.com/evantahler/actionhero_client)**

<img src="https://raw.github.com/evantahler/actionHero/master/public/logo/actionHero.png" height="300"/>

[![Nodei stats](https://nodei.co/npm/actionHero.png?downloads=true)](https://npmjs.org/package/actionHero)

[![Nodejitsu Deploy Status Badges](https://webhooks.nodejitsu.com/evantahler/actionHero.png)](http://demo.actionherojs.com)

[![Build Status](https://secure.travis-ci.org/evantahler/actionHero.png?branch=master)](http://travis-ci.org/evantahler/actionHero)

## Who is the actionHero?
actionHero.js is a multi-transport API Server with integrated cluster capabilites and delayed tasks. The goal of actionHero is to create an easy-to-use toolkit for making **reusable** & **scalable** APIs.  Clients connected to an actionHero server can [**consume the api**](https://github.com/evantahler/actionHero/wiki/Actions), [**consume static content**](https://github.com/evantahler/actionHero/wiki/File-Server), and [**communicate with each other**](https://github.com/evantahler/actionHero/wiki/Chat).  actionHero is cluster-ready, with built in support for background tasks, 0-downtime deploys, and more.

Currently actionHero supports:

- [Web Clients](https://github.com/evantahler/actionHero/wiki/web): HTTP, HTTPS
- [Socket Clients](https://github.com/evantahler/actionHero/wiki/socket): TCP (telnet), TLS
- [Web Socket (Faye) clients](https://github.com/evantahler/actionHero/wiki/websocket): HTTP, HTTPS

[You can also make your own servers and transports.](https://github.com/evantahler/actionHero/wiki/Servers)

## Quick Start

- `npm install actionHero`
- `./node_modules/.bin/actionHero generate`
- `./node_modules/.bin/actionHero start`

## Want more?

- [Getting Started](https://github.com/evantahler/actionHero/wiki/Getting-Started)
- [Running actionHero](https://github.com/evantahler/actionHero/wiki/Running-ActionHero)
- [Read the documentation on the wiki](https://github.com/evantahler/actionHero/wiki)
- [View the release history](https://github.com/evantahler/actionHero/releases/)

## Who?
* The primary creator of the actionHero framework is [Evan Tahler](http://evantahler.com), but many others [have helped](https://github.com/evantahler/actionHero/graphs/contributors)
* Logo by [Ali Spagnola](http://alispagnola.com/)
* If you want to contribute to actionHero, contribute to the conversation on [github](https://github.com/evantahler/actionHero)

![trackBat](http://trackbat.com/api/track?tid=UA-29132597-1&dh=actionherojs.com&dp=/readme&dt=readme)

###
